<template>
  <main>
    <mt-page-title :with-border="false" :with-padding="true">
      <h1 class="has-text-weight-bold is-size-3">Gérer les invitations</h1>
    </mt-page-title>
    <mt-box padding="0">
      <section class="columns is-mobile is-relative is-vcentered is-multiline">
        <b-field class="column is-full-mobile">
          <b-autocomplete
            class="mt-auto-complete-border-less"
            :data="data"
            placeholder="Rechercher un email"
            icon="magnify"
            :loading="isFetching"
            clearable
            @typing="getAsyncData"
            @select="selectAutoComplete"
          >
            <template #empty>aucun résultat</template>
            <template #default="{ option }">
              <article class="columns is-mobile">
                <div class="column is-narrow" @click="ajouter(option)">
                  <span class="is-selected" :class="isAutoCompleteSelected(option)"
                    ><b-icon icon="check-circle"></b-icon>
                  </span>
                </div>
                <div class="column" @click="ajouter(option)">
                  {{ option.email }}
                </div>
                <div v-if="isAdmin" class="column is-narrow" @click="ajouter(option)">
                  <span class="mt-statut">{{ afficherOrganisme(option) }}</span>
                </div>
                <div class="column is-narrow" @click="ajouter(option)">
                  <span v-if="option.hasExpired" class="mt-statut">Invitation expirée</span>
                  <span v-else class="mt-statut">Invitation envoyée</span>
                </div>
              </article>
            </template>
          </b-autocomplete>
        </b-field>
        <b-field class="column is-narrow-tablet is-padding">
          <b-button
            class="mt-button is-size-8 mt-button-fin has-text-weight-semibold"
            type="is-primary"
            @click="modalInvitationOpen = true"
            >Inviter des personnes</b-button
          >
        </b-field>
      </section>
      <section class="mt-liste-selected is-hidden-mobile">
        <b-tag
          v-for="(invitation, index) in renvoyerEnvoyees"
          :key="`env${index}`"
          class="mt-selected"
          closable
          @close="removeSelectedEnvoyee(index)"
        >
          {{ invitation.email }}
        </b-tag>
        <b-tag
          v-for="(invitation, index) in renvoyerExpirees"
          :key="`exp${index}`"
          class="mt-selected"
          closable
          @close="removeSelectedExpiree(index)"
        >
          {{ invitation.email }}
        </b-tag>
      </section>
      <b-tabs v-model="tabSelected" class="mt-box-onglet mt-box-onglet-big-marge">
        <b-tab-item>
          <template #header>
            <span class="is-hidden-mobile">
              Invitations envoyées <b-tag rounded> {{ envoyees.length }} </b-tag>
            </span>
            <span class="is-hidden-tablet">
              Envoyées <b-tag rounded> {{ envoyees.length }} </b-tag>
            </span>
          </template>
          <div class="is-flex">
            <b-checkbox
              v-if="envoyees.length > 0"
              v-model="allEnv"
              :indeterminate="isIndeterminateEnvoyees"
              class="mt-box-all"
              @input="selectionnerAllEnvoyees"
            ></b-checkbox>
            <b-button
              v-if="renvoyerEnvoyees.length > 0"
              type="is-text"
              icon-left="send"
              :title="`Renvoyer l'invitation au(x) ${renvoyerEnvoyees.length} personne(s) selectionée(s)`"
              @click="renvoyerInvitationsEnvoyees(renvoyerEnvoyees)"
            >
            </b-button>
            <b-button
              v-if="renvoyerEnvoyees.length > 0"
              type="is-text"
              icon-left="delete"
              :title="`Supprimer les ${renvoyerEnvoyees.length} invitation(s) selectionée(s)`"
              @click="supprimerInvitationsEnvoyees(renvoyerEnvoyees)"
            >
            </b-button>
          </div>
          <article class="mt-box-content">
            <mt-list v-slot="{ item: invitation }" :list="envoyees">
              <mt-list-item class="columns is-mobile" :row-class="isSelected(invitation)">
                <div class="column is-over">
                  <b-checkbox v-model="renvoyerEnvoyees" :native-value="invitation"></b-checkbox>
                  <span class="mt-email" :title="titleInvitation(invitation)">{{ invitation.email }} </span>
                </div>
                <div class="columns column is-mobile is-narrow">
                  <div class="column is-hidden-mobile ">
                    <span v-if="isAdmin" class="mt-statut is-right">{{ afficherOrganisme(invitation) }}</span>

                    <span class="mt-date-expiration is-right" title="date d'expiration">{{
                      dateFormatter(invitation.precription)
                    }}</span>
                  </div>
                  <div class="column is-narrow">
                    <div class="action-buttons ">
                      <b-button
                        v-if="!(renvoyerEnvoyees.length > 0)"
                        class="mt-button-action-on-hover"
                        type="is-text"
                        icon-left="send"
                        title="Renvoyer l'invitation"
                        @click="renvoyerInvitationsEnvoyees([invitation])"
                      >
                      </b-button>
                      <b-button
                        v-if="!(renvoyerEnvoyees.length > 0)"
                        type="is-text"
                        class="mt-button-action-on-hover"
                        icon-left="delete"
                        title="Supprimer l'invitation"
                        @click="supprimerInvitationsEnvoyees([invitation])"
                      >
                      </b-button>
                    </div>
                  </div>
                </div>
              </mt-list-item>
            </mt-list>
          </article>
        </b-tab-item>
        <b-tab-item>
          <template #header>
            <span class="is-hidden-mobile">
              Invitations expirées <b-tag rounded> {{ expirees.length }} </b-tag>
            </span>
            <span class="is-hidden-tablet">
              Expirées <b-tag rounded> {{ expirees.length }} </b-tag>
            </span>
          </template>
          <div class="is-flex">
            <b-checkbox
              v-if="expirees.length > 0"
              v-model="allExp"
              :indeterminate="isIndeterminateExpirees"
              class="mt-box-all"
              @input="selectionnerAllExpirees"
            ></b-checkbox>
            <b-button
              v-if="renvoyerExpirees.length > 0"
              type="is-text"
              icon-left="send"
              :title="`Renvoyer l'invitation au(x) ${renvoyerExpirees.length} personne(s) selectionée(s)`"
              @click="renvoyerInvitationsExpirees(renvoyerExpirees)"
            >
            </b-button>
            <b-button
              v-if="renvoyerExpirees.length > 0"
              type="is-text"
              icon-left="delete"
              :title="`Supprimer les ${renvoyerExpirees.length} invitation(s) selectionée(s)`"
              @click="supprimerInvitationsExpirees(renvoyerExpirees)"
            >
            </b-button>
          </div>
          <article class="mt-box-content">
            <mt-list v-slot="{ item: invitation }" :list="expirees">
              <mt-list-item class="columns is-mobile" :row-class="isSelected(invitation)">
                <div class="column is-over">
                  <b-checkbox v-model="renvoyerExpirees" :native-value="invitation"></b-checkbox>
                  <span class="mt-email" :title="titleInvitation(invitation)">{{ invitation.email }} </span>
                </div>
                <div class="columns column is-mobile is-narrow">
                  <div class="column is-hidden-mobile ">
                    <span v-if="isAdmin" class="mt-statut is-right">{{ afficherOrganisme(invitation) }}</span>

                    <span class="mt-date-expiration is-right" title="date d'expiration">{{
                      dateFormatter(invitation.precription)
                    }}</span>
                  </div>
                  <div class="column is-narrow">
                    <div class="action-buttons ">
                      <b-button
                        v-if="!(renvoyerExpirees.length > 0)"
                        class="mt-button-action-on-hover"
                        type="is-text"
                        icon-left="send"
                        title="Renvoyer l'invitation"
                        @click="renvoyerInvitationsEnvoyees([invitation])"
                      >
                      </b-button>
                      <b-button
                        v-if="!(renvoyerExpirees.length > 0)"
                        type="is-text"
                        class="mt-button-action-on-hover"
                        icon-left="delete"
                        title="Supprimer l'invitation"
                        @click="supprimerInvitationsExpirees([invitation])"
                      >
                      </b-button>
                    </div>
                  </div>
                </div>
              </mt-list-item>
            </mt-list>
          </article>
        </b-tab-item>
      </b-tabs>
    </mt-box>
    <mt-modal-ok :ouvert.sync="modalInvitationEnvoyeeOpen">
      <div v-if="compteRendu.creations > 0" class="mt-info-message">
        Les invitations ont bien été envoyées.
      </div>
      <div v-if="compteRendu.rejets > 0" class="mt-warning">
        {{ compteRendu.rejets }} invitations ont été rejetées : les comptes existaient déjà.
      </div>
      <div v-if="compteRendu.fauxEmails && compteRendu.fauxEmails.length > 0" class="mt-warning">
        Les adresses suivantes n'étant pas des mails valides,<br />
        les invitations n'ont pu être envoyées :
        <ul>
          <li v-for="email in compteRendu.fauxEmails" :key="email">
            {{ email }}
          </li>
        </ul>
      </div>
    </mt-modal-ok>
    <mt-modal-ok :ouvert.sync="modalInvitationSupprimeeOpen">
      <div v-if="compteRendu.suppressions === 0" class="mt-info-message">
        Aucune invitation supprimée.
      </div>
      <div v-if="compteRendu.suppressions === 1" class="mt-info-message">
        Une invitation a bien été supprimée.
      </div>
      <div v-if="compteRendu.suppressions > 1" class="mt-info-message">
        {{ compteRendu.suppressions }} invitations ont bien été supprimées.
      </div>
    </mt-modal-ok>
    <mt-modal-ok
      :ouvert.sync="modalInvitationOpen"
      message-expanded
      class="is-hidden-mobile"
      @update:ouvert="resetEmailsAndTags"
    >
      <form @submit.prevent="envoyerInvitation">
        <b-field class="mt-marginless-bottom" :label="`destinataires (${emailsTags.length})`">
          <vue-tags-input
            v-model="emailsText"
            :tags="emailsTags"
            :add-on-key="[';', ',']"
            placeholder="Ajoutez des adresses mails"
            class="mt-input"
            :validation="validation"
            @tags-changed="tagChange"
          ></vue-tags-input>
        </b-field>
        <mt-message-info class="has-text-weight-bold"
          >Pour valider la saisie d'une adresse ou en séparer plusieurs, utiliser ";" ou ","</mt-message-info
        >
        <b-field label="profils">
          <b-field grouped group-multiline class="profil-liste">
            <b-checkbox
              v-for="(profil, index) in profils"
              :key="index"
              v-model="invitationData.profils"
              :native-value="profil"
              class="column"
              @input="verifProfils(profil)"
            >
              <span>{{ profil.description }}</span>
            </b-checkbox>
          </b-field>
        </b-field>
        <b-field label="poste au RO (facultatif)">
          <b-field>
            <b-select v-model="invitationData.posteRo" placeholder="Sélectionner un poste" expanded>
              <option :value="null">
                ---
              </option>
              <option v-for="posteRo in postesRo" :key="posteRo.id" :value="posteRo">
                {{ posteRo.libelle }}
              </option>
            </b-select>
          </b-field>
        </b-field>
        <section v-if="isAdmin" class="columns is-multiline">
          <b-field
            v-for="(typeOrganisme, index) in typesOrganismes"
            :key="index"
            :label="typeOrganisme.libelle"
            class="field column is-half "
          >
            <b-select
              v-model="organismes[index]"
              :placeholder="typeOrganisme.libelle"
              required
              expanded
              @input="majTypeOrganisme(index)"
            >
              <option v-for="organisme in typeOrganisme.organismes" :key="organisme.id" :value="organisme">
                {{ organisme.code }}
              </option>
            </b-select>
          </b-field>
        </section>
        <mt-message-info v-else class="has-text-weight-bold"
          >Le pax sera invité au titre de l'unité sélectionnée, c'est-à-dire {{ organisme.codeParent }} /
          {{ organisme.code }}</mt-message-info
        >
        <article class="field is-grouped is-grouped-centered">
          <p class="control">
            <b-button class="mt-button is-size-8" type="is-primary" native-type="submit">
              Envoyer les invitations
            </b-button>
          </p>
        </article>
      </form>
      <template #buttons> <div></div></template>
    </mt-modal-ok>
    <mt-modal-ok
      :ouvert.sync="modalInvitationOpen"
      message-expanded
      :full-screen="true"
      class="is-hidden-tablet"
      @update:ouvert="resetEmailsAndTags"
    >
      <form @submit.prevent="envoyerInvitation">
        <b-field class="mt-marginless-bottom" :label="`destinataires (${emailsTags.length})`">
          <vue-tags-input
            v-model="emailsText"
            :tags="emailsTags"
            :add-on-key="[';', ',']"
            placeholder="Ajoutez des adresses mails"
            class="mt-input"
            :validation="validation"
            @tags-changed="tagChange"
          ></vue-tags-input>
        </b-field>
        <mt-message-info class="has-text-weight-bold"
          >Pour valider la saisie d'une adresse ou en séparer plusieurs, utiliser ";" ou ","</mt-message-info
        >
        <b-field label="profils">
          <b-field grouped group-multiline class="profil-liste">
            <b-checkbox
              v-for="(profil, index) in profils"
              :key="index"
              v-model="invitationData.profils"
              :native-value="profil"
              class="column"
              @input="verifProfils(profil)"
            >
              <span>{{ profil.description }}</span>
            </b-checkbox>
          </b-field>
        </b-field>
        <b-field label="poste au RO (facultatif)">
          <b-field>
            <b-select v-model="invitationData.posteRo" placeholder="Sélectionner un poste" expanded>
              <option :value="null">
                ---
              </option>
              <option v-for="posteRo in postesRo" :key="posteRo.id" :value="posteRo">
                {{ posteRo.libelle }}
              </option>
            </b-select>
          </b-field>
        </b-field>
        <section v-if="isAdmin" class="columns is-multiline">
          <b-field
            v-for="(typeOrganisme, index) in typesOrganismes"
            :key="index"
            :label="typeOrganisme.libelle"
            class="field column is-half "
          >
            <b-select
              v-model="organismes[index]"
              :placeholder="typeOrganisme.libelle"
              required
              expanded
              @input="majTypeOrganisme(index)"
            >
              <option v-for="organisme in typeOrganisme.organismes" :key="organisme.id" :value="organisme">
                {{ organisme.code }}
              </option>
            </b-select>
          </b-field>
        </section>
        <article class="field is-grouped is-grouped-centered">
          <p class="control">
            <b-button class="mt-button is-size-8 has-text-weight-semibold" type="is-primary" native-type="submit">
              Envoyer les invitations
            </b-button>
          </p>
        </article>
      </form>
      <template #buttons> <div></div></template>
    </mt-modal-ok>
  </main>
</template>

<script>
import { VueTagsInput, createTag, createTags } from '@johmun/vue-tags-input';
import debounce from 'lodash/debounce';
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtMessageInfo from '~/components/base/message/mt-message-info';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import MtModalOk from '~/components/modal/mt-modal-ok';
import userMixin from '~/components/mixins/userMixin';

export default {
  components: {
    MtModalOk,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
    VueTagsInput,
    MtMessageInfo,
  },
  mixins: [userMixin],
  data() {
    return {
      selected: null,
      tabSelected: 0,
      allExp: false,
      allEnv: false,
      renvoyerExpirees: [],
      renvoyerEnvoyees: [],
      data: [],
      isFetching: false,
      modalInvitationOpen: false,
      modalInvitationEnvoyeeOpen: false,
      modalInvitationSupprimeeOpen: false,
      emailsText: '',
      emailsTags: [],
      organismes: [],
      compteRendu: {},
      message: '',
      validation: [
        {
          classes: 'no-email',
          rule: /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
        },
      ],
    };
  },
  computed: {
    isIndeterminateExpirees() {
      return this.renvoyerExpirees.length > 0 && this.renvoyerExpirees.length !== this.expirees.length;
    },
    isIndeterminateEnvoyees() {
      return this.renvoyerEnvoyees.length > 0 && this.renvoyerEnvoyees.length !== this.envoyees.length;
    },
  },
  watch: {
    selected({ hasExpired }) {
      if (hasExpired) {
        this.changerTab(1);
      } else {
        this.changerTab(0);
      }
    },
    organisme: {
      handler() {
        this.refreshListe();
      },
    },
    renvoyerEnvoyees: {
      handler(newValue) {
        this.allEnv = newValue.length === this.envoyees.length && this.envoyees.length > 0;
      },
    },
    renvoyerExpirees: {
      handler(newValue) {
        this.allExp = newValue.length === this.expirees.length && this.expirees.length > 0;
      },
    },
  },
  async asyncData({ $api, store }) {
    const [profils, postesRo, profilsParDefault] = await Promise.all([
      $api.utilisateurs.creationProfils(),
      $api.postesRo.full(),
      $api.profils.getDefaultSimple(),
    ]);
    let invitationReq = $api.organisme().invitations();
    const isAdmin = store.getters['context/isAdmin'];
    let typesOrganismes = null;
    if (isAdmin) {
      typesOrganismes = await $api.typesOrganismes.allWithFirstChildOrganisme();
      invitationReq = $api.tokenUtilisateur.all();
    }
    const { envoyees, expirees } = await invitationReq;
    return {
      envoyees,
      expirees,
      profils,
      postesRo,
      typesOrganismes,
      invitationData: {
        emails: '',
        profils: [profilsParDefault],
        organismeAffectation: {},
        posteRo: {},
      },
    };
  },
  methods: {
    dateFormatter(date) {
      return DateTime.fromISO(date)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy');
    },
    afficherOrganisme({ organisme: { code, codeParent } }) {
      if (codeParent != null) {
        return `${codeParent}/${code}`;
      }
      return `${code}`;
    },
    async majTypeOrganisme(index) {
      const idOrganismeSelectionner = this.organismes[index].id;
      if (this.typesOrganismes.length > index + 1) {
        for (let i = index + 1; i < this.typesOrganismes.length; i += 1) {
          this.typesOrganismes[i].organismes = {};
          this.organismes[i] = { id: 0 };
        }
        this.typesOrganismes[index + 1].organismes = await this.$api.organismes.organismesByParent(
          idOrganismeSelectionner,
        );
      }
    },
    tagChange(newTags) {
      const tags = [];
      newTags.forEach((tag) => {
        const textTag = tag.text;
        const ltags = textTag.split(/ |,|;/);
        ltags.forEach((ltag) => {
          const mtag = this.replaceAll(ltag, ' ', '');
          if (mtag !== '') {
            tags.push(mtag);
          }
        });
      });
      this.emailsTags = createTags(tags, this.validation);
    },
    replaceAll(text, replace, replacement) {
      if (typeof String.prototype.replaceAll === 'undefined') {
        return text.replace(new RegExp(replace, 'g'), () => replacement);
      }
      return text.replaceAll(replace, replacement);
    },
    selectionnerAllExpirees(value) {
      this.renvoyerExpirees = [];
      if (value) {
        this.expirees.forEach((invitation) => {
          this.renvoyerExpirees.push(invitation);
        });
      }
    },
    selectionnerAllEnvoyees(value) {
      this.renvoyerEnvoyees = [];
      if (value) {
        this.envoyees.forEach((invitation) => {
          this.renvoyerEnvoyees.push(invitation);
        });
      }
    },

    async renvoyerInvitationsEnvoyees(invitations) {
      this.compteRendu = await this.$api.utilisateurs.renouvellementInscriptionByToken(invitations);
      this.refreshListeAndOpenMessage();
      this.renvoyerEnvoyees = [];
    },
    async renvoyerInvitationsExpirees(invitations) {
      this.compteRendu = await this.$api.utilisateurs.renouvellementInscriptionByToken(invitations);
      this.refreshListeAndOpenMessage();
      this.renvoyerExpirees = [];
    },

    async supprimerInvitationsEnvoyees(invitations) {
      this.compteRendu = await this.$api.utilisateurs.supprimerInscription(invitations);
      this.refreshListeAndOpenMessageSuppression();
      this.renvoyerEnvoyees = [];
    },
    async supprimerInvitationsExpirees(invitations) {
      this.compteRendu = await this.$api.utilisateurs.supprimerInscription(invitations);
      this.refreshListeAndOpenMessageSuppression();
      this.renvoyerExpirees = [];
    },
    refreshListeAndOpenMessage() {
      this.modalInvitationEnvoyeeOpen = true;
      this.refreshListe();
    },
    refreshListeAndOpenMessageSuppression() {
      this.modalInvitationSupprimeeOpen = true;
      this.refreshListe();
    },
    async refreshListe() {
      let invitationReq = this.$api.organisme().invitations();
      if (this.isAdmin) {
        invitationReq = this.$api.tokenUtilisateur.all();
      }
      const { envoyees, expirees } = await invitationReq;
      this.envoyees = envoyees;
      this.expirees = expirees;
    },
    titleInvitation({ createur: { nom, prenom } }) {
      if (nom && prenom) {
        return `Invitation envoyée par ${nom} ${prenom}`;
      }
      return '';
    },
    changerTab(index) {
      this.tabSelected = index;
    },
    isSelected(invitation) {
      if (this.renvoyerEnvoyees.includes(invitation) || this.renvoyerExpirees.includes(invitation)) {
        return 'mt-list-item-selected';
      }
      return '';
    },
    verifProfils(profil) {
      this.verifProfil(profil, 'employeur', 'super_employeur');
      this.verifProfil(profil, 'super_employeur', 'employeur');
      this.verifProfil(profil, 'employe', 'super_employe');
      this.verifProfil(profil, 'super_employe', 'employe');
    },
    verifProfil(profil, p1, p2) {
      let i = 0;
      if (profil.code === p1) {
        this.invitationData.profils.forEach((mProfil) => {
          if (mProfil.code === p2) {
            this.invitationData.profils.splice(i, 1);
          }
          i += 1;
        });
      }
    },
    validateEmail(email) {
      const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },
    async envoyerInvitation() {
      if (this.emailsText) {
        this.emailsTags.push(createTag(this.emailsText, this.emailsTags));
      }
      this.invitationData.emails = this.emailsTags.map((value) => value.text).join(';');
      if (this.isAdmin) {
        this.invitationData.organismeAffectation = this.organismes[this.organismes.length - 1];
      } else {
        this.invitationData.organismeAffectation = this.organisme;
      }
      const emails = this.invitationData.emails.split(';');
      let isValideEmail = true;
      for (let i = 0; i < emails.length; i += 1) {
        if (!this.validateEmail(emails[i])) {
          isValideEmail = false;
          break;
        }
      }
      if (isValideEmail || this.emailsTags.length === 0) {
        try {
          this.compteRendu = await this.$api.utilisateurs.inscriptionByToken(this.invitationData);
          this.modalInvitationOpen = false;
          this.refreshListeAndOpenMessage();
          this.resetEmailsAndTags();
        } catch ({
          response: {
            status,
            data: { message },
          },
        }) {
          this.$buefy.notification.open({
            message,
            type: 'is-warning',
            duration: 5000,
          });
        }
      } else {
        this.$buefy.notification.open({
          message: 'Des adresses mails sont invalides',
          type: 'is-warning',
          duration: 5000,
        });
      }
    },
    resetEmailsAndTags() {
      this.emailsTags = [];
      this.emailsText = '';
    },
    isAutoCompleteSelected(option) {
      const searchExp = this.renvoyerExpirees.find((value) => value.email === option.email);
      const searchEnv = this.renvoyerEnvoyees.find((value) => value.email === option.email);
      if (searchExp || searchEnv) {
        return 'mt-list-item-selected';
      }
      return '';
    },
    ajouter(option) {
      if (option.hasExpired) {
        if (!this.renvoyerExpirees.find((value) => value.email === option.email)) {
          this.renvoyerExpirees.push(option);
        }
      } else if (!this.renvoyerEnvoyees.find((value) => value.email === option.email)) {
        this.renvoyerEnvoyees.push(option);
      }
    },
    removeSelectedEnvoyee(index) {
      this.renvoyerEnvoyees.splice(index, 1);
    },
    removeSelectedExpiree(index) {
      this.renvoyerExpirees.splice(index, 1);
    },
    selectAutoComplete(option) {
      this.selected = option;
    },
    getAsyncData: debounce(async function getAsyncData(search) {
      this.isFetching = true;
      let rechercheReq = this.$api.organisme().rechercheInvitations(search);
      if (this.isAdmin) {
        rechercheReq = this.$api.tokenUtilisateur.rechercheInvitations(search);
      }
      try {
        if (search != null && search.length > 0) {
          this.data = await rechercheReq;
        } else {
          this.data = [];
        }
      } catch (e) {
        this.$buefy.toast.open({
          message: 'Une erreur est survenue lors de la récupération des données.',
          type: 'is-danger',
        });
      } finally {
        this.isFetching = false;
      }
    }, 500),
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-box {
  min-height: 80vh;
}
.mt-filter-liste {
  margin-top: 1rem;
}
footer {
  padding: 0.5rem 0;
  margin-bottom: 1rem;
}
.mt-auto-complete-border-less {
  margin: 1rem 3.1vw 0;
}
/deep/ .mt-list-item {
  display: flex;
  align-items: center;
}
.mt-email {
  flex-grow: 1;
  padding: 0.38em 0;
}
/deep/ .mt-box-all {
  margin: 0.5rem 0.8rem;
}
.button.mt-button-fin {
  margin-right: 2rem;
}
.mt-modal {
  .field {
    margin-bottom: 1.5rem;
  }
  .columns.is-multiline {
    margin-bottom: 1.5rem;

    .field {
      margin-bottom: 0;
    }
  }
}

.field.has-addons {
  justify-content: space-between;
}

/deep/ {
  .ti-tag.ti-deletion-mark {
    color: white;
  }

  .ti-tags {
    align-items: flex-start;
    max-height: 120px;
    align-content: flex-start;
    overflow-y: auto;
  }

  .ti-tag {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: $primary;
    font-size: 0.75rem;
    padding: 0.2em 0.8em;
    margin: 5px;
  }
  .mt-info {
    margin-bottom: 1.5rem;
  }
}
.profil-liste {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  gap: 0.5em;
  grid-gap: 0.5em;
}
.mt-info-message {
  margin: 0.5em 0;
  text-align: left;
}
.mt-warning {
  margin: 0.5em 0;
  text-align: left;
  color: $puce-indisponible;

  ul {
    margin: 0.5em 1em;
  }

  li {
    list-style-type: disc;
  }
}
.mt-date-expiration {
  background-color: $pale-grey;
  color: $soft-blue;
  border-radius: 2em;
  font-size: 0.6875rem;
  padding: 0.3em 1.5em;
  cursor: default;
  text-align: center;
}
.is-selected {
  color: #dfdfdf;

  &.mt-list-item-selected {
    color: $soft-blue;
  }
}
.mt-liste-selected {
  padding: 0 4em;
  align-items: center;
}
.mt-selected {
  background-color: $pale-grey;
  color: #666ee8;
  padding: 0.5em 1em;
  margin: 0.25em;
  font-size: 0.6875rem;
  cursor: default;
}
.is-padding {
  padding-left: 2em;
}
.is-right {
  float: right;
}
.is-over {
  overflow: hidden;
  text-overflow: ellipsis;
}
/deep/ .control.has-icons-left .icon {
  color: $brown-grey;
}
</style>
